/************************************************
 *		The Master Class		*
 *----------------------------------------------*
 * This class will run the state inside the	*
 * task with the highest priority.  The tasks	*
 * will be inside a list of processes.  Ideally *
 * each process would get to run its highest	*
 * priority state at the same time.  However,	*
 * we can't do this with out multiple computers *
 ************************************************/

#ifndef ___MASTERH___
#define ___MASTERH___

#include <list>

class CProcess;		// Forward declare because CProcess includes us

class CMaster
{
	public:
		CMaster();
		~CMaster();

		addproc(CProcess *aProc);
		print_proc();	// For debuging only
	
	private:
		list<CProcess *> the_processes;
		typedef list<CProcess *>::const_iterator LI;

};

#endif
