#include "task.h"
#include "process.h"
#include "state.h"

CTask::CTask(CProcess *myProc, string name)
	: name(name)
{
	myProc->addtask(this);
	
	CurrentState = NULL;
}

CTask::~CTask()
{
	for(LI i=my_states.begin(); i != my_states.end(); ++i)
	{
		CState *astate = *i;
		delete astate;
	}
	my_states.clear();
}

CTask::run()
{
	if(CurrentState != NULL)
	{
		if(first_run)
			CurrentState->entry();
		
		first_run = false;
		CurrentState->action();
		
		CState *answer = CurrentState->chtest();
		if(answer != NULL)
		{
			first_run = true;
			CurrentState = answer;
		}
	}
}

CTask::addstate(CState *newstate)
{
	my_states.push_front(newstate);
}
